{****************************************************************************
**
*W  commentator.p          Homology source                  DHS 
**
*H  @(#)$Id: commentator.p,v 0.0 1999/08
**
*Y  Copyright (C)  1996,  Us guys
**
**  This file implements the Pascal interface to commentators (for 
**  providing runtime commentary to the user)

** commentator.p header for Pascal code corresponding to commentator.h for C++ 
*}

unit Commentator_Pas;

interface

type
  TCommentator = Pointer;

const
  { Min and Max }
  { initializing commentator with PrintEverything, everything should be printed.}
  { initializing commentator with PrintNothing, nothing should be printed. }
  PrintEverything = 100000;
  PrintNothing = 0;

  { Msg Class }
  TimingMeasure	= 1;
  TimingEstimate	= 2;
  PartialResult	= 3;
  InternalWarning	= 4;
  InternalError	= 5;
  InternalDescription = 6;

  { Msg Level }
  LvlAlways = -1;
  LvlImp    = 0;
  LvlNormal = 1;
  LvlUnimp  = 2;
  LvlBlabla = 10;

function InitializeCommentator(timing,	
			       homology	: integer): TCommentator;
asmname 'initializeCommentator';
{ Create a commentator object reference.}

procedure StartActivity(Com : TCommentator;
			id, 
			msg: cstring; 
			msglevel, 
			msgclass: integer); 
asmname 'startActivity';
{ Start an activity, indentation level will be increased, 
  printlevel = activity depth + msglevel.  }

procedure StopActivity(Com : TCommentator;
		       msg : cstring;
		       msglevel, 
		       msgclass: integer); 
asmname 'stopActivity';
{ Stop an activity, indentation level will be decreased. } 

procedure ActivityReport(Com: TCommentator;
			 msg: cstring; 
			 msglevel, 
			 msgclass: integer); 
asmname 'activityReport';
{ Provides a message to the commentary object C for possible printing/display.}

procedure ProgressReport(Com: TCommentator;
			 msg: cstring; 
			 msglevel, 
			 k, n: integer); 
asmname 'progressReport';
{ Provides a message to the commentary object assuming k out of n steps of the activity have been completed. }
{ This allows the Commentator to make time estimates.}

function IsPrinted(Com: TCommentator;
 	   msglevel,
		   msgclass: integer): integer; 
asmname 'isPrinted';
{ Returns 0 if messages of this level and class will not be printed,
  non-zero if they will be printed.}

implementation

end.
