/* translation of 
{
  Copyright 1997-99 by Frank Heckenbach, heckenb@mi.uni-erlangen.de

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, version 2.
 
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Comp_Hom;

interface

uses GPC, Commentator_Pas, Tools, Simplicial, GMP, Arith, Arith_GMP, Arith_Valence;

procedure ComputeHomology (var Commentator : TCommentator; var Facets : TFacets; MinDim, MaxDim : TCount; Algorithm, Mode, Coeff_i : Integer; Numerator, Denominator : String);
procedure ComputeBoundaryMap (var Commentator : TCommentator; var Facets : TFacets; MinDim, MaxDim : TCount);
procedure ComputeBoundaryMapFile (var Commentator : TCommentator; var Facets : TFacets; MinDim : TCount; const FileName : String);

*/
#include "simplicial.h"
#include "commentator.h"

void ComputeHomology (Commentator& comm, 
		      TFacets Facets, TCount MinDim, TCount MaxDim,
		      long Algorithm, long Mode, long Coeff_i, 
		      char* Numerator, char* Denominator );

void ComputeBoundaryMap (Commentator& comm, 
		         TFacets Facets, TCount MinDim, TCount MaxDim);

void ComputeBoundaryMapFile (Commentator& comm, 
		             TFacets Facets, TCount MinDim, 
                             char* FileName);

// implementation elsewhere
