#include "integer.h"
#include "compgmp.h"
extern "C" {
#include "gmp.h"
}

#define sign(l)    ((l) <0 ? -1 : (l >0 ? 1 : 0)) 

//----------miscellaneous inline functions

int Integer::priv_sign() const {
      return mpz_sgn( (mpz_ptr)&gmp_rep );
}



//-------------------------------------------------- operator +
const Integer Integer::operator + (const Integer& n) const
{
  if (iszero(n)) return *this;
  if (iszero(*this)) return n;

  Integer Res ;   
  mpz_add( (mpz_ptr)&Res.gmp_rep, (mpz_ptr)&gmp_rep, (mpz_ptr)&n.gmp_rep );
  return Res ;
}  


//-------------------------------------------------- operator -
const Integer Integer::operator - (const Integer& n) const
{
  if (iszero(n)) return *this;
  if (iszero(*this)) return -n;

  Integer Res ;
  mpz_sub( (mpz_ptr)&Res.gmp_rep, (mpz_ptr)&gmp_rep, (mpz_ptr)&n.gmp_rep );
  return Res ;
}



const Integer Integer::operator - () const
{
//     Integer Res(*this) ; // logical recopy
//     Res.gmp_rep.size = - gmp_rep.size ;
// JGD 18.06.1999
    Integer Res ;
    mpz_neg((mpz_ptr)&Res.gmp_rep, (mpz_ptr)&gmp_rep ); 
    return Res ;
}


//-------------------------------------------------- operator +
const Integer Integer::operator + (const int l) const 
{ return operator+(Integer(l)) ; }

const Integer Integer::operator + (const long l) const 
{ return operator+(Integer(l)) ; }


//-------------------------------------------------- operator -
const Integer Integer::operator - (const int l) const 
{ return operator-(Integer(l)) ; }

const Integer Integer::operator - (const long l) const 
{ return operator-(Integer(l)) ; }


