// ========================================================================== //
// Defintion of class Integer
// (c) copyright GIVARO 1994
// author: M.Samama
// date: 1994
// review: T.Gautier
// Gmp version : 1.906 or 1.3.2
// ========================================================================== //
//-------------------------------------------------inline comparaison operators
  inline int operator != (const Integer& a , const Integer& b)
    { return compare(a,b) != 0 ; }

  inline int operator != (int l, const Integer& n)
    { return n.operator != (l); }

  inline int operator != (long l, const Integer& n)
    { return n.operator != (l); }

  inline int operator == (const Integer& a, const Integer& b) 
    {  return compare(a,b) == 0 ; }

  inline int operator == (int l, const Integer& n)
    { return (! (n.operator != (l))); }

  inline int operator == (long l, const Integer& n)
    { return (! (n.operator != (l))); }

  inline int operator == (const Integer& n, int l)
    { return (! (n.operator != (l))); }

  inline int operator == (const Integer& n, long l)
    { return (! (n.operator != (l))); }

  inline int operator < (const Integer& a , const Integer& b)
    { return compare(a,b) < 0 ; }

  inline int operator < (const int l, const Integer& n)
    { return n > l; }

  inline int operator < (const long l, const Integer& n)
    { return n > l; }

  inline int operator >  (const Integer& a , const Integer& b)
    { return compare(a,b) > 0 ; }

  inline int operator > (int l, const Integer& n)
    { return n < l; }

  inline int operator > (long l, const Integer& n)
    { return n < l; }

  inline int operator <= (const Integer& a, const Integer& b)
    { return compare(a,b) <= 0 ; }

  inline int operator <= (const Integer& n, int l)
    {  return (! (n > l) ); }

  inline int operator <= (const Integer& n, long l)
    {  return (! (n > l) ); }

  inline int operator <= (int l, const Integer& n)
    {  return (! (n < l) );}

  inline int operator <= (long l, const Integer& n)
    {  return (! (n < l) );}

  inline int operator >= (const Integer& a, const Integer& b)
    { return compare(a,b) >= 0 ; }

  inline int operator >= (int l, const Integer& n)
    {  return (! (n > l) );}

  inline int operator >= (long l, const Integer& n)
    {  return (! (n > l) );}

  inline int operator >= (const Integer& n, int l)
    {  return (! (n < l) );}

  inline int operator >= (const Integer& n, long l)
    {  return (! (n < l) );}


//----------------------------------arithmetic inline operators

  inline const Integer operator + (int l, const Integer& n)
    { return n + l; }

  inline const Integer operator + (long l, const Integer& n)
    { return n + l; }

  inline const Integer operator + (const Integer& n, ulong l)
    { return n + Integer(l); }

  inline const Integer operator + (ulong l, const Integer& n)
    { return n + Integer(l); }

  inline const Integer operator += (Integer& a, const Integer& b)
    {  return a = a + b; }

  inline const Integer operator += (Integer& n, int l)
    {  return n = n + l; }

  inline const Integer operator += (Integer& n, long l)
    {  return n = n + l; }

  inline const Integer operator += (Integer& n, ulong l)
    {  return n = n + Integer(l); }

  inline const Integer operator - (int l, const Integer& n)
    { return (-n) + l; }

  inline const Integer operator - (long l, const Integer& n)
    { return (-n) + l; }

  inline const Integer operator - (const Integer& n, ulong l)
    { return n - Integer(l); }

  inline const Integer operator - (ulong l, const Integer& n)
    { return Integer(l) - n; }

  inline const Integer operator -= (Integer& a, const Integer& b)
    {  return a = a - b; }

  inline const Integer operator -= (Integer& n, int l)
    { return n = n - l; }

  inline const Integer operator -= (Integer& n, long l)
    { return n = n - l; }

  inline const Integer operator -= (Integer& n, ulong l)
    { return n = n - Integer(l); }

  inline const Integer operator * (int l, const Integer& n)
    {  return n * l; }

  inline const Integer operator * (long l, const Integer& n)
    {  return n * l; }

  inline const Integer operator * (ulong l, const Integer& n)
    {  return n * Integer(l); }

  inline const Integer operator * (const Integer& n, ulong l)
    { return n * Integer(l); }

  inline const Integer operator *= (Integer& a, const Integer& b)
    {  return a = a * b; }

  inline const Integer operator *= (Integer& n, int l)
    {  return n = n * l; }

  inline const Integer operator *= (Integer& n, long l)
    {  return n = n * l; }

  inline const Integer operator *= (Integer& n, ulong l)
    {  return n = n * Integer(l); }

  inline const Integer operator /= (Integer& a, const Integer& b)
    {  return a = a / b; }

  inline const Integer operator /= (Integer& a, int l )
    {  return a = a / l; }

  inline const Integer operator /= (Integer& a, ulong l )
    {  return a = a / Integer(l); }

  inline const Integer operator %= (Integer& a, const Integer& b)
    { return a = a % b; }

  inline const Integer operator %= (Integer& n, int l)
    { return n = n % l; }

  inline const Integer operator %= (Integer& n, long l)
    { return n = n % l; }

  inline const Integer operator %= (Integer& n, ulong l)
    { return n = n % Integer(l); }


//----------miscellaneous inline functions

  inline int iszero(const Integer& a) {
          // JGD 18.06.1999 because of alpha's
//       return (a.gmp_rep.size ==0) ;
      return (a.priv_sign() == 0);
  }

  inline int sign(const Integer& a) {
          // JGD 18.06.1999 because of alpha's
//       return (a.gmp_rep.size ==0 ? 0 : (a.gmp_rep.size < 0 ? -1 : 1)) ; 
     return a.priv_sign() ; 
  }

  inline int isone(const Integer& a) 
    { return (a.gmp_rep.size < 1 ? 0 : (a.gmp_rep.d[0] == 1UL ? 1 : 0)) ; }

  inline ulong length(const Integer& a) 
    { return (a.gmp_rep.size < 0 ? -a.gmp_rep.size 
                     : a.gmp_rep.size) * sizeof(ulong) ; }

  inline const Integer operator <<= (Integer& n, unsigned int l)
    {  return n = n << l; }

  inline const Integer operator <<= (Integer& n, unsigned long l)
    {  return n = n << l; }

  inline const Integer operator >>= (Integer& n, unsigned int l)
    {  return n = n >> l; }

  inline const Integer operator >>= (Integer& n, unsigned long l)
    {  return n = n >> l; }
