// =================================================================== //
// Givaro : Prime numbers
//              Factor sets,
// Needs list structures : stl ones for instance
// Time-stamp: <01 Jun 99 14:51:16 Jean-Guillaume.Dumas@imag.fr> 
// =================================================================== //

#ifndef _GIVARO_FACTORISATION_H_
#define _GIVARO_FACTORISATION_H_

#include <list>
using std::list;
#include "integer.h"
#include "intprime.h"

// =================================================================== //
// Set or list of divisors, factors.
// =================================================================== //
unsigned long factorset(const Integer&, list<Integer>&, list<unsigned long>&);
void factorset(const Integer&, list<Integer>&, list<long>&) ;
void factorset_Erathostene(const Integer&, list<Integer>&) ;
void factorset(const Integer&, list<Integer>&);
void divisors(const Integer&, list<Integer>&);

#define small_factorset factorset_Erathostene
#define big_factorset factorset
#define Integer_factorset(n,L) ((n)<BOUNDARY_factor ? small_factorset(n,L) : big_factorset(n,L))

#endif
