#include "integer.h"
#include <iostream>
//#include <iostream.h>
using std::cerr;
using std::cout;
using std::endl;
#include <stdlib.h>
#include "compgmp.h"
extern "C"
{
#include "gmp.h"
}
#include "giverror.h"

/*
// Sortie nonsignee : 321321 meme si n = -321321, par exemple 
ostream& absOutput(ostream &o, const Integer&n)
{
  int base = 10;
  
  unsigned long strSize = mpz_sizeinbase((mpz_ptr)&(n.gmp_rep), base) + 2;
  char *str = ::new char[strSize];
  mpz_get_str(str, base, (mpz_ptr)&(n.gmp_rep));
  if (sign(n) < 0) {
      char *str1 = &(str[1]) ;
      o << str1;
  }
  else o << str;
  ::delete [] str ;
  return o;
} 
*/

// Sortie signee : +321321 ou -321321, par exemple 
std::ostream& operator << (std::ostream &o, const Integer&n)
{
  //!!!
  int base = 10;
  size_t strSize = mpz_sizeinbase((mpz_ptr)&(n.gmp_rep), base)+2;
  char *str = ::new char[strSize];
  mpz_get_str(str, base, (mpz_ptr)&(n.gmp_rep));
//  if (sign(n) > 0) o << '+' ;
  o << str;
  ::delete [] str ;
  return o;
} 

  // Entree au format de la sortie
std::istream& operator>> (std::istream& in, Integer& a)
{
   static long base[10] = {
     10,
     100,
     1000,
     10000,
     100000,
     1000000,
     10000000,
     100000000,
     1000000000
   } ;
   if (!in.good())
   {
      throw GivError("*** error: corruped stream, in operator>> for Integer") ;
      return in ;
   }
   if (!in) return in ;
   // eat white
   char ws;
   in >> ws  ;

   // Base : 10^9, we read by packet of length 9
   // the char.
   char Tmp[10] ;
   int counter = 0 ;

   // Set the returned integer
   a = 0L ;
   char ch ;
   int sign = 1 ;

   // find a sign:
   in.get(ch) ;
   if ((ch != '+') && (ch != '-') && !((ch >= '0') && (ch <= '9')))
   {
      cerr << "Bad integer format: found: "<< ch ;
      cerr << ", in place of '+' '-' or a digit"<< endl ;
      return in ;
   }
   switch (ch) {
     case '+' : break ;
     case '-' : sign = -1 ; break ;
     default  : in.putback(ch) ; break ;
   }
   // eat white
   in >> ws  ;

   int noend = 1 ;
   while (noend)
   {
      counter = 0 ;

      // Read 9 digits or less
      while ((noend) && (counter < 9)) {
         in.get(ch) ;
         if (in.eof()) { noend = 0 ; }
         else if ((ch >= '0') && (ch <= '9')) Tmp[counter++] = ch ;
         else { noend = 0 ;  in.putback(ch) ; }
      }
      if (counter >0) {
         long l ;
         Tmp[counter] = '\0' ; // terminate the string
         l = atol(Tmp) ;
         a = a * base[counter-1] + l ;
      }
   }
   if (sign == -1) a = -a ;  
   return in ;
}
