#include "integer.h"
#include "compgmp.h"
extern "C" {
#include "gmp.h"
}


// 
const Integer Integer::operator * (const Integer &n) const
{
  if (iszero(*this)) return *this ;
  if (iszero(n)) return n ;

  Integer Res ; 
  mpz_mul( (mpz_ptr)&(Res.gmp_rep), (mpz_ptr)&gmp_rep, (mpz_ptr)&(n.gmp_rep) ) ;
  return Res ;
}
  

//
const Integer Integer::operator * (const int l) const
{ 
  if (iszero(*this)) return *this ;
  if (l == 0) return Integer(0L) ;

  ulong ll = (l <0 ? -l : l );
  Integer Res ;
  mpz_mul_ui( (mpz_ptr)&(Res.gmp_rep), (mpz_ptr)&gmp_rep, ll) ;
  if (l <0) Res.gmp_rep.size = -Res.gmp_rep.size ;
  return Res ;
}

//
const Integer Integer::operator * (const long l) const
{ 
  if (iszero(*this)) return *this ;
  if (l == 0) return Integer(0L) ;

  ulong ll = (l <0 ? -l : l );
  Integer Res ;
  mpz_mul_ui( (mpz_ptr)&(Res.gmp_rep), (mpz_ptr)&gmp_rep, ll) ;
  if (l <0) Res.gmp_rep.size = -Res.gmp_rep.size ;
  return Res ;
}
