// =================================================================== //
// Givaro : Theoreme Chinois des Restes
// Time-stamp: <28 May 99 18:36:11 Jean-Guillaume.Dumas@imag.fr> 
// =================================================================== //
#ifndef _GIVARO_CHINESE_REMAINDER_THEOREM_
#define _GIVARO_CHINESE_REMAINDER_THEOREM_

#include "integer.h"
#include <list>
using std::list;

const Integer tcr(list<Integer>& Lr, list<Integer>& Lm) {
        // Lr[0] = res mod Lm[0], Lr[1] = res mod Lm[1], ...
    Integer t,bt,m1,mk;
    Integer d,v;
    list<Integer> Lg;
    list<Integer>::iterator k = Lm.begin();
    m1 = *k;
    k++;
    for(;k!=Lm.end();k++) {
        mk = *k;
        t = m1 % mk;
        list<Integer>::iterator i = Lm.begin();
        i++;
        for(;i!=k;i++)
            t= (t * (*i)) % mk;
        Integer g;
        d = gcd(t,mk,g,v);
        if (d != 1) {
            cerr << "*** inversion by zero in: TCR " << endl;
            cerr << t << '*'<< g << '+' << mk << '*' << v << '=' << t*g+mk*v << endl ;
            cerr << "and gcd = " << d << endl;
            cerr << "so 1/" << t << " mod " << mk << " does not exist." << endl;
            return d;
        }
        Lg.push_back(g);
    }
    list<Integer>::iterator ig=Lg.begin();
    list<Integer>::iterator im=Lm.begin();
    Integer pk,gk,pm=*im;
    im++;
    list<Integer>::iterator ir = Lr.begin();
    Integer u = (*ir) % pm;
    ir++;
    for(;ir!=Lr.end();ir++,ig++,im++) {
        pk = *ir;
        gk = *ig;
        mk = *im;
        t = ((pk-u)*gk) % mk;
        u = u + t * pm;
        pm = pm * mk ;
    }
    return u;
}



const Integer& tcr(Integer& res, Integer& pm, list<Integer>& Lr, list<Integer>& Lm) {
        // Lr[0] = res mod Lm[0], Lr[1] = res mod Lm[1], ...
    Integer t,bt,m1,mk;
    Integer d,v;
    list<Integer> Lg;
    list<Integer>::iterator k = Lm.begin();
    m1 = *k;
    k++;
    for(;k!=Lm.end();k++) {
        mk = *k;
        t = m1 % mk;
        list<Integer>::iterator i = Lm.begin();
        i++;
        for(;i!=k;i++)
            t= (t * (*i)) % mk;
        Integer g;
        d = gcd(t,mk,g,v);
//         if (d != 1) {
//             cerr << "*** inversion by zero in: TCR " << endl;
//             cerr << t << '*'<< g << '+' << mk << '*' << v << '=' << t*g+mk*v << endl ;
//             cerr << "and gcd = " << d << endl;
//             cerr << "so 1/" << t << " mod " << mk << " does not exist." << endl;
//             return res=d;
//         }
        Lg.push_back(g);
    }
    list<Integer>::iterator ig=Lg.begin();
    list<Integer>::iterator im=Lm.begin();
    Integer pk,gk;
    pm = *im;
    im++;
    list<Integer>::iterator ir = Lr.begin();
    Integer u = (*ir) % pm;
    ir++;
    for(;ir!=Lr.end();ir++,ig++,im++) {
        pk = *ir;
        gk = *ig;
        mk = *im;
        t = ((pk-u)*gk) % mk;
        u = u + t * pm;
        pm = pm * mk ;
    }
    return res=u;
}

#endif
