#ifndef __B_B_H__
#define __B_B_H__
// ======================================================
// Copyright (C)  LinBox Project 1999
//
// Black Blox Trait
// file : lin_b_b.h
// ======================================================

/**********************************
 * Info types about BB matrices
 **********************************/
class default_BB {};
class BB_with_transpose : public virtual default_BB {};

const long infty = -1;

/**********************************
 * Black Box Requirements
 * Default BlackBox is identity
 **********************************/

template< class XXX>
struct BlackBox
{
    typedef default_BB BB_info;

    long n_row() const { return infty; };
    long n_col() const { return infty; };

    typedef XXX PreferredInMatrix;
    typedef XXX PreferredOutMatrix;
    typedef XXX coefficientSpace;
    
    template<class InMatrix, class OutMatrix>
    OutMatrix& Apply(OutMatrix& outM, const InMatrix& inM ) {
        return outM;
    }

        // Optional, if it exists BB_info should be set to BB_with_transpose
    template<class InMatrix, class OutMatrix>
    OutMatrix& ApplyTrans(OutMatrix& outM, const InMatrix& inM ) {
        return outM;
    }

};

#endif
