// ======================================================================= //
// Copyright (C)  1999, Linbox project.
// Givaro / Athapascan-1
// Elements matriciels et vectuers creux
// Time-stamp: <31 Jul 00 17:13:29 Jean-Guillaume.Dumas@imag.fr> 
// ======================================================================= //

#ifndef _GIV_PAIR_H_
#define _GIV_PAIR_H_
// #include <givrandom.h>
#include <givtype.h>

// -------------------------------------
// a non zero value in a matrix line
// struct { column index, value }
template<class T>
class GivPair {
public:
    GivPair() {};
    GivPair(const Indice jj, const T& val) :_j(jj),_value(val){};
//    ~GivPair() {};

    T getvalue() const {
        return _value;
    };

    Indice getindex() const {
        return _j;
    };

    Indice j() const {
        return _j;
    };
    
    T change_value(const T& val) { return _value = val; };

    T affect(const T& val) {
        return _value = val;
    };      
            
    GivPair<T> assign(const T& val) {
        _value = val;
        return *this;
    };      
            
    GivPair<T> assign(const Indice jj, const T& val) {
        _value = val;
        _j = jj;
        return *this;
    };      
            
    void decr() {};      
            
    Indice change_j(const Indice jj) {
        return _j = jj;
    };      
            
      // ----------------------
      // Champs    
    
private:
    Indice _j;
    T _value;
    
};


#include <iostream>
template<class T> inline std::istream& operator>> (std::istream& is, GivPair<T>& a){
        Indice jj;
        T val;
        is >> jj >> val;
        a = GivPair<T>(jj,val);
        return is;
};
    
template<class T> inline std::ostream& operator<< (std::ostream& o, const GivPair<T> a){
        return o << a.j() << " " << a.getvalue()  ;
};
    
#ifndef _SPARSE_VECTOR_H_
#define _SPARSE_VECTOR_H_

#include <vector>
using std::vector;
template<class T>
class Sparse_Vector : public std::vector< GivPair<T> > {
public:
    typedef GivPair<T> elements;
    typedef T coefficientSpace;

    Sparse_Vector() {};
    Sparse_Vector(size_t n) : std::vector< GivPair<T> >(n), _rsize(0) {};
    Sparse_Vector(size_t n, size_t rn) : std::vector< GivPair<T> >(n), _rsize(rn) {};

        // ----------------------
        // Space dimension

    inline size_t realsize() const {
        return _rsize;
    };

    inline size_t actualsize() const { return _rsize; };            
    inline size_t reactualsize( const size_t s ) { return _rsize = s; };
    template<class XX> inline size_t reactualsize( const XX s ) { return _rsize
 = (size_t)s; };            

private:
    size_t _rsize;
};    

template<class T> 
inline std::ostream& operator<< (std::ostream& o, const Sparse_Vector<T> v){
        if (v.size())
            for(Indice i=0;i<v.size();i++)
                o << v[i] << endl;
        return o;
};


#endif
#endif
