#ifndef _INDETER_H_
#define _INDETER_H_
// ========================================================================
// file:  indeter.h
// author: T. Gautier
// (c) PAC Team
// date: 1995
// version: 
// Description:
// Representation of the variables of polynomials
// Bugs:
// ========================================================================
#include "givcounter.h"

//class ostream ; class istream ; 
#include <iostream>

// Degree Type: for polynomial.
typedef long Degree ;
// Degree of the null polynomial.
const Degree deginfty  = -1 ;

class Indeter {
public :
       
   // Cstor
   Indeter(const char *s = "") ;
   Indeter(const Indeter& s) ;

   // Dstor
virtual ~Indeter() ;

   // Affectation et recopie physique du nom de l'indeterminee
   // Affectation
   Indeter& operator= (const Indeter& s) ;
   Indeter& logcpy(const Indeter& s) ;
inline Indeter& memcpy(const Indeter& s)  ;

   // Comparaisons : Toutes les comparaisons
   // sont basees sur l'existance d'une fonction
   // membre "compare" qui retourne : -1 si this < s,
   // 0 si this = s, et 1 si this > s.

virtual int compare(const Indeter& b)  const ;
	
inline int operator== (const Indeter &s) const ;
inline int operator!= (const Indeter &s) const ;
inline int operator<= (const Indeter &s) const ;
inline int operator<  (const Indeter &s) const ;
inline int operator>= (const Indeter &s) const ;
inline int operator>  (const Indeter &s) const ;

friend  std::ostream& operator<< (std::ostream &o, const Indeter &s) ;
friend  std::istream& operator>> (std::istream &o, Indeter &s) ;

// Gilles 23.08.94 ==> Relecture d'un expert ?
inline  char*  chaine() const {return name; }   

private:
  Counter* refcount ;
  char* name ;
} ;


  // Inline members functions :

inline Indeter& Indeter::memcpy(const Indeter& s) 
    { return operator= (s) ; }

inline int Indeter::operator==(const Indeter &s) const 
   { return compare(s) == 0 ; }

inline int Indeter::operator!=(const Indeter &s) const 
   { return ! (*this == s) ; }

inline int Indeter::operator<= (const Indeter &s) const  
   { return compare(s) <= 0 ; }

inline int Indeter::operator<  (const Indeter &s) const 
   { return compare(s) < 0 ; }

inline int Indeter::operator>= (const Indeter &s) const 
   { return compare(s) >= 0 ; }

inline int Indeter::operator>  (const Indeter &s) const
   { return compare(s) > 0 ; }

#endif
