// ========================================================================== //
// Univariate polynomial
// class Poly1<T>
// (c) copyright GIVARO 1994
// author: Th. Gautier....
// date: 1994
// bugs: unknown
// ========================================================================== //

/*
template <class T>
const Poly1<T> Poly1<T>::Zero (zero);
template <class T>
const Poly1<T> Poly1<T>::One (one) ;
*/

// Default cstor vide     (JGD 01.04.97)
template <class T>
Poly1<T>::Poly1 ( ) : Array1<T>(1), X("")
{
//  Array1<T>::reallocate(1) ; // JGD 21.05.97
  write( 0, T(zero) ) ;
  deg = deginfty ;
}


template <class T>
Poly1<T>::Poly1 (const Neutral n ) : Array1<T>(1), deg(0), X("")
{
//  Array1<T>::reallocate(1) ; // JGD 21.05.97
  write( 0, T(n) ) ;
  if (n == zero) deg = deginfty ;
}


template <class T>
Poly1<T>::Poly1 (const T &cste) : Array1<T>(1), deg(0), X("")
{
//  Array1<T>::reallocate(1) ; // JGD 21.05.97
  write( 0, cste ) ;
  if (iszero(cste)) deg = deginfty ;
}

template <class T>
Poly1<T>::~Poly1 () 
{ }

template <class T>
Poly1<T>::Poly1 (const Poly1<T>& P) 
 : X(P.X), deg(P.deg), Array1<T>(P)
{ }

template <class T>
Poly1<T>::Poly1 (const Indeter& Y, const Degree d )
 : Array1<T>(d+1), deg(d), X(Y)
{
  if (deg ==deginfty)
  {
     Array1<T>::reallocate(1) ;
//     Array1<T>::write(0, T(zero)) ; // JGD 13.05.99
     return ;
  }
//  for (int i=0 ; i< deg; i++)  // JGD 13.05.99
//    Array1<T>::write(i, T(zero)) ; // JGD 13.05.99
//  Array1<T>::write(deg, T(one)) ; // JGD 13.05.99
}

template <class T>
Poly1<T>::Poly1 (const Indeter& Y, const Degree d, const Array0<T>& tabcoef) 
 : Array1<T>(d+1), deg(d), X(Y)
{
  if (deg ==deginfty) 
  {
     Array1<T>::reallocate(1) ;
     Array1<T>::write(0, T(zero)) ;
     return ;
  }
  for (int i  = 0; i <= d ; i++) 
    Array1<T>::write(i, tabcoef[i]) ;
}

template <class T>
Poly1<T>::Poly1 (const Indeter& Y, const Degree d, const T* tabcoef) 
 : Array1<T>(d+1), deg(d), X(Y)
{
  if (deg ==deginfty) 
  {
     Array1<T>::reallocate(1) ;
     Array1<T>::write(0, T(zero)) ;
     return ;
  }
  for (int i  = 0; i <= d ; i++) 
    Array1<T>::write(i, tabcoef[i]) ;
}

// This = lcoeff*X^deg 
template <class T>
Poly1<T>::Poly1 (const Indeter& Y, const Degree d, const T& lcoeff) 
 : Array1<T>(d+1), deg(d), X(Y)
{
  if (deg ==deginfty) 
  {
     Array1<T>::reallocate(1) ;
     Array1<T>::write(0, T(zero)) ;
     return ;
  }
  for (int i=0 ; i< deg; i++) 
    Array1<T>::write(i, T(zero)) ;
  Array1<T>::write(deg, lcoeff ) ;
}

