#ifndef _GIVERROR_H_
#define _GIVERROR_H_
// ==========================================================================
// file: giverror.h
// author: T. Gautier
// (c) Givaro Team
// date: 1995
// version: 2.7
// Description:
// - error exception 
// Bugs:
// ==========================================================================

#include <iostream>


  // Base class for execption handling in Givaro
class GivError {
public:
 GivError(const char* msg ) 
 : strg(msg) {} ;

virtual void print( std::ostream& o )  const ;
friend std::ostream& operator<< (std::ostream& o, const GivError& E) ;

protected:
const char* strg ;
} ;

class GivMathError : public GivError {
public:
  GivMathError(const char* msg) : GivError(msg) {} ;
} ;

class GivMathDivZero : public GivMathError {
public:
  GivMathDivZero(const char* msg) : GivMathError(msg) {} ;
} ;

#endif
