#ifndef _GIVARO_POWER_H_
#define _GIVARO_POWER_H_

// ==========================================================================
// file: givpowers.h 
// Time-stamp: <22 Jul 99 12:56:48 Jean-Guillaume.Dumas@imag.fr>
// (c) Givaro Team
// ==========================================================================

// -------------------------------------------------------------
// Powering
// -------------------------------------------------------------
#include <givtype.h>

template<class TT> TT mod_power(const TT n, const TT l) {
  if (l == 0) return 1 ;

  ulong p = l ;
  short is_assg = 0 ;

  ulong res = 1L ;
  ulong puiss  = n ;

  while (p != 0) {
    if (p & 0x1) 
        if (is_assg) 
           res *= puiss ;
        else { 
           is_assg = 1 ; 
           res = puiss ; 
        }
    if ((p >>= 1) != 0) puiss = puiss * puiss ;
  }
  return res ;
}

#include <math.h>

template<> double mod_power(const double a, const double e) {
   return pow(a,e);
}

#endif
