// ======================================================================= //
// Class Timer :
// (c) copyright GIVARO 1994
// date: 1994
// ======================================================================= //

#include <math.h>
extern "C" {
#include <sys/time.h>
#include <sys/resource.h>
// JGD 07.10.99
//  int getrusage (int, struct rusage*) ;
}
#include <iostream.h>
#include "timer.h"

// Return a value to initialize random generator 
long BaseTimer::seed() 
{
  struct timeval tp;
  gettimeofday(&tp, 0) ;
  return(tp.tv_usec);
  return 1 ;
}


// Output the value of the timer :
ostream& operator<<(ostream& o, const BaseTimer& T) 
{
  return o << T._t ;
}

// Some arithmetic operator :
BaseTimer& BaseTimer::operator = (const BaseTimer & T) 
{  
  _t = T._t ; 
  return *this ; 
}
      
// Computes and returns interval of time
// beteween *this and T
const BaseTimer BaseTimer::operator - (const BaseTimer & T)  const
{
  BaseTimer Tmp ;
  Tmp._t = _t - T._t ; 
  return Tmp ;
}

const BaseTimer BaseTimer::operator - () 
{
  BaseTimer Tmp ;
  Tmp._t = -_t ; 
  return Tmp ;
}

const BaseTimer BaseTimer::operator + (const BaseTimer & T)  const
{
  BaseTimer Tmp ;
  Tmp._t = _t + T._t ; 
  return Tmp ;
}

const BaseTimer BaseTimer::operator / (int i) 
{
  BaseTimer Tmp ;
  Tmp._t = _t / i;
  return Tmp;
}



/*
a1cOStream& operator<< ( a1cOStream& o, const BaseTimer& T) 
{
   return o << T._t ;
}

a1cIStream& operator>> ( a1cIStream& o, BaseTimer& T) 
{
   return o >> T._t ;
}
*/
   // Start timer
void RealTimer::start()
{  
  struct timeval tmp2 ;  // to gettimeofday  (real time)
  gettimeofday (&tmp2, 0) ;

  // real time 
  _t = (double) tmp2.tv_sec + 
    ((double) tmp2.tv_usec)/ (double)BaseTimer::MSPSEC ; 
}


// Stop timer 
void RealTimer::stop()
{ 
  struct timeval tmp2 ;  // to gettimeofday  (real time)
  gettimeofday (&tmp2, 0) ;

  // real time 
  _t = (double) tmp2.tv_sec + 
    ((double) tmp2.tv_usec)/ (double)BaseTimer::MSPSEC - _t ; 
}

// Start timer
void UserTimer::start()
{
  struct rusage  tmp1 ;  // to getrusage (sys+user times)
  getrusage (RUSAGE_SELF, &tmp1) ;
  // user time
  _t = (double) tmp1.ru_utime.tv_sec +
    ((double) tmp1.ru_utime.tv_usec)/ (double)MSPSEC ;
}


// Stop timer
void UserTimer::stop()
{
  struct rusage  tmp1 ;  // to getrusage (sys+user times)
  getrusage (RUSAGE_SELF, &tmp1) ;
  // user time
  _t = (double) tmp1.ru_utime.tv_sec +
    ((double) tmp1.ru_utime.tv_usec)/ (double)MSPSEC - _t ;
}


// Start timer
void SysTimer::start()
{
  struct rusage  tmp1 ;  // to getrusage (sys+user times)
  getrusage (RUSAGE_SELF, &tmp1) ;
  // user time
  _t = (double) tmp1.ru_stime.tv_sec +
    ((double) tmp1.ru_stime.tv_usec)/ (double)MSPSEC ;
}


// Stop timer
void SysTimer::stop()
{
  struct rusage  tmp1 ;  // to getrusage (sys+user times)
  getrusage (RUSAGE_SELF, &tmp1) ;
  // user time
  _t = (double) tmp1.ru_stime.tv_sec +
    ((double) tmp1.ru_stime.tv_usec)/ (double)MSPSEC - _t ;
}



// Clear timer :
void Timer::clear() 
{ RealTimer::clear() ; UserTimer::clear(); SysTimer::clear() ; }

// Start timer
void Timer::start() 
{ RealTimer::start() ; UserTimer::start(); SysTimer::start() ; }

// Stop timer
void Timer::stop() 
{ RealTimer::stop() ; UserTimer::stop(); SysTimer::stop() ; }


ostream& operator<<(ostream& o, const Timer& T) 
{
  o << "user time: " << T.usertime() << '\n' ;
  o << "sys. time: " << T.systime() << '\n' ;
  o << "real time: " << T.realtime() << endl ;
  return o ;
}

// Some arithmetic operator :
Timer& Timer::operator = (const Timer & T)
{
  UserTimer::_t = T.UserTimer::_t ; 
  SysTimer::_t  = T.SysTimer::_t ; 
  RealTimer::_t = T.RealTimer::_t ;
  return *this ;
}

// CompUserTimer::_tes and returns interval of time
// beteween *this and T
const Timer Timer::operator - (const Timer & T)  const
{
  Timer Tmp ;
  Tmp.UserTimer::_t = UserTimer::_t - T.UserTimer::_t ;
  Tmp.SysTimer::_t = SysTimer::_t - T.SysTimer::_t ;
  Tmp.RealTimer::_t = RealTimer::_t - T.RealTimer::_t ;
  return Tmp ;
}

const Timer Timer::operator - ()
{
  Timer Tmp ;
  Tmp.UserTimer::_t = -UserTimer::_t ;
  Tmp.SysTimer::_t = -SysTimer::_t ;
  Tmp.RealTimer::_t = -RealTimer::_t ;
  return Tmp ;
}

const Timer Timer::operator + (const Timer & T)  const
{
  Timer Tmp ;
  Tmp.UserTimer::_t = UserTimer::_t + T.UserTimer::_t ;
  Tmp.SysTimer::_t = SysTimer::_t + T.SysTimer::_t ;
  Tmp.RealTimer::_t = RealTimer::_t + T.RealTimer::_t ;
  return Tmp ;
}

const Timer Timer::operator/(int i) 
{
  Timer Tmp ;
  Tmp.UserTimer::_t = UserTimer::_t / i ;
  Tmp.SysTimer::_t = SysTimer::_t / i ;
  Tmp.RealTimer::_t = RealTimer::_t / i ;
  return Tmp ;
}

/*
a1cOStream& operator<< ( a1cOStream& o, const Timer& T)
{
   return o << T.UserTimer::_t << T.SysTimer::_t << T.RealTimer::_t ;
}

a1cIStream& operator>> ( a1cIStream& o, Timer& T)
{
  return o >> T.UserTimer::_t >> T.SysTimer::_t >> T.RealTimer::_t ;
}
*/
