/****************************************************************************
**
*W  smith_form.C          Homology source                  Dumas & Saunders
**
*H  @(#)$Id: smith_form.C,v 0.0 1999/08
**
*Y  Copyright (C)  1999,  Us guys
*T Time-stamp: <02 Aug 00 17:04:04 Jean-Guillaume.Dumas@imag.fr> 
**
*/

//#include <stdio.h>
#include <iostream>
#include "integer.h"
#include "commentator.h"
//#include "matrix.h"
#include "matrix.C"

#include <vector>
#include <list>
using std::vector;
using std::list;

extern "C" {
#include "gmp.h"
}

#include "lin_sparse_b_b.h" 
typedef BlackBox< _IBB_VECTOR_ < Sparse_Vector < long > > > SPBBlong;

int main(int argc, char ** argv) {

        // command line :
        // Filename, Hom level, Tim level, Method, Mode, coeff.
	// or
	// Filename, Hom level, Tim level, Method, Mode, coeff, numerator, denominator
    if ((argc != 7) && (argc != 9)) {
        cerr << "Wrong number of command-line arguments (" << (argc-1) << ")." << endl;
        return 1;
    }

    Invariants<ulong> SmithForm;
    SPBBlong TheMat;
    char * File_Name = argv[1];
    long ni, nj;
    ni = TheMat.get_n_row(File_Name);   
    nj = TheMat.n_col();
    int Method =  atoi(argv[4]);

    if (Method != hmValenceBB) {
        if (ni > nj)
            TheMat.fileset_transpose(File_Name);
        else
            TheMat.fileset(File_Name);
    }
  
    Commentator GlobComm = Commentator(atoi(argv[3]),atoi(argv[2]));

    MatrixSmithFormValenceCPP(GlobComm, TheMat, ni, nj, File_Name, Method, atoi(argv[5]), Integer(argv[6]), SmithForm, argv[7], argv[8] );

    cout << "[" << SmithForm.n_row() << ", " << SmithForm.n_col() ;
    for(TCount i=0; i<SmithForm.size(); ++i) {
        cout << ", [" << SmithForm.getvalue(i) << ", " << SmithForm.getexponent(i) << "]";
    }
    cout << "]";

    return 0;
}
